#ifndef __ADABOOST_H__
#define __ADABOOST_H__
#define __LEARNING_MODEL_AGGREGATION_ADABOOST_H__

#include "types/boosting.h"

class AdaBoost : public Boosting
{
 private:
    static const char name_version[] = "AdaBoost.M1 11/03/2001";

 public:
    AdaBoost (size_t n_input, size_t n_output, size_t max);
    AdaBoost (AdaBoost &ag);
    virtual const char* version () { return name_version; }

    virtual AdaBoost* copy ();

 protected:
    REAL *init_wgt;
    virtual REAL train (REAL **x, REAL **y, size_t n, REAL *wgt = NULL);
    virtual void update_weights (size_t k, REAL **x, REAL **y, size_t n);
};

#else /* def __ADABOOST_H__ */

#ifndef __LEARNING_MODEL_AGGREGATION_ADABOOST_H__
#error This header file conflicts with another "adaboost.h" file.
#endif

#endif
