#ifndef __ADABOOT_M2_H__
#define __ADABOOT_M2_H__
#define __LEARNING_MODEL_AGGREGATION_ADABOOT_M2_H__

#include "classnn.h"
#include "types/boosting.h"

class AdaBoost_M2 : public Boosting
{
 private:
    static const char name_version[] = "AdaBoost.M2 11/11/2001";

 public:
    AdaBoost_M2 (size_t n_input, size_t n_output, size_t max);
    AdaBoost_M2 (AdaBoost_M2 &ag);
    virtual const char* version () { return name_version; }

    virtual AdaBoost_M2* copy ();

 protected:
    REAL **comp_wgt, *samp_wgt;
    virtual REAL train (REAL **x, REAL **y, size_t n, REAL *wgt = NULL);
    REAL train_sub (REAL **x, REAL **y, size_t n);
    virtual void update_weights (size_t k, REAL **x, REAL **y, size_t n);
};

#else /* def __ADABOOT_M2_H__ */

#ifndef __LEARNING_MODEL_AGGREGATION_ADABOOT_M2_H__
#error This header file conflicts with another "adaboost_m2.h" file.
#endif

#endif
