#ifndef __AVERAGE_H__
#define __AVERAGE_H__
#define __LEARNING_MODEL_AGGREGATION_AVERAGE_H__

#include "types/aggregation.h"

class Average : public Aggregation
{
 private:
    static const char name_version[] = "Average 10/27/2001";

 public:
    Average (size_t n_input, size_t n_output, size_t max);
    Average (Average &ag);
    virtual const char* version () { return name_version; }

 protected:
    virtual void aggregate (REAL *y);

 public:
    virtual Average* copy ();
    virtual BOOL support_weighted_data () { return TRUE; }
    virtual void initialize ();
    virtual REAL train (REAL **x, REAL **y, size_t n, REAL *wgt = NULL);
 };

#else /* def __AVERAGE_H__ */

#ifndef __LEARNING_MODEL_AGGREGATION_AVERAGE_H__
#error This header file conflicts with another "average.h" file.
#endif

#endif
