#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include "data.h"

/* utilities */
void rv_print (RVEC rv, size_t n)
{
    while (n--)
        printf("%.4f  ", *rv++);
    printf("\n");
}

size_t rv_read (FILE *f, RVEC rv, size_t n)
{
    size_t i;
    assert(f != NULL);
    assert(rv != NULL);
    for (i = 0; i < n; i++) {
        int c = fscanf(f, "%lf", rv);
        if (c < 1) {
            /*fprintf(stderr, "rv_read: line too short (%d)\n", i);*/
            return i;
        }
        rv++;
    }
    return n;
}

size_t rm_read (FILE *f, RVEC *rm, size_t m, size_t n)
{
    size_t i;

    assert(f != NULL);
    assert(rm != NULL);
    for (i = 0; i < m; i++) {
        int c;
        size_t n_read;

        n_read = rv_read(f, rm[i], n);
        if (n_read < n) {
            fprintf(stderr, "rm_read: file contains only %d data\n", i);
            return i;
        }
        do {
            c = fgetc(f);
        } while (c != '\n' && c != EOF);
    }
    return m;
}

size_t rm_write (FILE *f, RVEC *rm, size_t m, size_t n)
{
    size_t i, j;

    assert(f != NULL);
    assert(rm != NULL);
    for (i = 0; i < m; i++) {
        for (j = 0; j < m; j++)
            fprintf(f, "%g ", rm[i][j]);
        fputc('\n', f);
    }
    return m;
}
