#ifndef __NNLAYER_MOMENTUM_H__
#define __NNLAYER_MOMENTUM_H__
#define __LEARNING_MODEL_NNLAYER_MOMENTUM_H__

#include "types/nnlayer.h"

class NNLayer_Momentum : public NNLayer
{
 private:
    static const char name_version[] = "NNLayer_Momentum 10/27/2001";

 protected:
    REAL momentum_ratio;

 public:
    NNLayer_Momentum (size_t num_input, size_t num_neuron);
    NNLayer_Momentum (size_t num_input, size_t num_neuron, REAL r);
    NNLayer_Momentum (NNLayer_Momentum &ml);
    virtual const char* version () { return name_version; }

    virtual NNLayer_Momentum* copy ();

    void set_momentum_ratio (REAL r);
    virtual void update_weight (REAL learn_rate);
};

#else /* def __NNLAYER_MOMENTUM_H__ */

#ifndef __LEARNING_MODEL_NNLAYER_MOMENTUM_H__
#error This header file conflicts with another "nnlayer_momentum.h" file.
#endif

#endif
