#ifndef __BAGGING_H__
#define __BAGGING_H__
#define __LEARNING_MODEL_AGGREGATION_BAGGING_H__

#include "aggregation.h"

class Bagging : public Aggregation
{
 private:
    static const char name_version[] = "Bagging 10/30/2001";

 public:
    Bagging (size_t n_input, size_t n_output, size_t max);
    Bagging (Bagging &ag);
    virtual const char* version () { return name_version; }

 protected:
    virtual void aggregate (REAL *y);

 public:
    virtual Bagging* copy ();
    virtual BOOL support_weighted_data () { return TRUE; }
    virtual void initialize ();
    virtual REAL train (REAL **x, REAL **y, size_t n, REAL *wgt = NULL);
};

#else /* def __BAGGING_H__ */

#ifndef __LEARNING_MODEL_AGGREGATION_BAGGING_H__
#error This header file conflicts with another "bagging.h" file.
#endif

#endif
