#ifndef __BOOSTING_H__
#define __BOOSTING_H__
#define __LEARNING_MODEL_AGGREGATION_BOOSTING_H__

#include "aggregation.h"

class Boosting : public Aggregation
{
 private:
    static const char name_version[] = "Boosting 11/13/2001";

 protected:
    REAL *boost_wgt, *lm_wgt;
    /* boost_wgt: only valid within train */

 public:
    Boosting (size_t n_input, size_t n_output, size_t max);
    Boosting (Boosting &ag);
    virtual const char* version () { return name_version; }

    virtual BOOL save_model (FILE *f);
    virtual BOOL load_model (FILE *f);
    virtual Boosting* copy ();

 protected:
    virtual void aggregate (REAL *y);
    virtual void update_weights (size_t k, REAL **x, REAL **y, size_t n);

 public:
    virtual BOOL support_weighted_data () { return TRUE; }
    virtual void initialize ();
    virtual REAL train (REAL **x, REAL **y, size_t n, REAL *wgt = NULL);

    virtual void convert_log_weight ();
};

#else /* def __BOOSTING_H__ */

#ifndef __LEARNING_MODEL_AGGREGATION_BOOSTING_H__
#error This header file conflicts with another "boosting.h" file.
#endif

#endif
