#ifndef __LEARNMODEL_H__
#define __LEARNMODEL_H__
#define __LEARNING_MODEL_LEARNMODEL_H__

#include <stdio.h>
#include "types.h"
#include "dataset.h"
#include "object.h"

class LearnModel : public Object
{
 private:
    static const char name_version[] = "LearnModel 10/26/2001";

 protected:
    size_t input_dim, output_dim;
    FILE *logf; /* file to record train/validate error */

 public:
    LearnModel (size_t n_input = 0, size_t n_output = 0);
    LearnModel (LearnModel &lm);
    virtual ~LearnModel();
    virtual const char* version () { return name_version; }

    virtual LearnModel* copy () = 0;

    size_t get_n_input  () { return input_dim;  }
    size_t get_n_output () { return output_dim; }
    void set_log_file (FILE *f) { logf = f; }

public:
    REAL test (DataSet &Data);         /* data.y will not be modified */
//  Matrix get_output (Matrix &in);
    void get_output (DataSet &data);   /* data.y: rewritten by real output */
    REAL train2 (DataSet &Data);

    virtual BOOL support_weighted_data ();
    virtual void initialize () = 0;
    virtual REAL error (REAL *out, REAL *y);
    virtual REAL train (REAL **x, REAL **y, size_t n, REAL *wgt = NULL) = 0;
    virtual void get_output (REAL *x, REAL *y) = 0;
};

#else /* def __LEARNMODEL_H__ */

#ifndef __LEARNING_MODEL_LEARNMODEL_H__
#error This header file conflicts with another "learnmodel.h" file.
#endif

#endif
