/*************************************** NOT FOR DISTRIBUTION ***
 * Filename : types.h                                           *
 *  Version : 0.01.0011                                         *
 * Compiler : Borland C++ 3.1                                   *
 *  Created : 97/03/13         Last Modified: 01/08/21          *
 *  Include :                                                   *
 ********************************************************* Ice **
 * Descript : Here defines some data types & operators (in C).  *
 ****************************************************************
 *  History : see types.his                                     *
 ****************************************************************/

/* CAUTION:
          . Before using this header file, you can run
                     testtype.c
            to confirm the compatiblity with your system.
          . In order to be compatible with early version, the macro
                     _LOWCASE_TYPEDEF_
            is needed. Thus the lowcase type such as ulong, uint will
            be defined.
*/

#ifndef __TYPES_H__
#define __TYPES_H__
#define __COMMON_TYPES_TYPES_H__

/*#define _USE_MY_SIZE_T_ : THIS PART IS STILL UNDER WORK */

/*
 * Basic types & constants
 */

/*
  We should suppose the range of some default data types as bellow:
              char            0 -- 127         (          0 -- +0x7F      )
             short       -32767 -- +32767      (    -0x7FFF -- +0x7FFF    )
      signed short       -32767 -- +32767      (    -0x7FFF -- +0x7FFF    )
    unsigned short            0 -- +65535      (          0 -- +0xFFFF    )
               int       -32767 -- +32767      (    -0x7FFF -- +0x7FFF    )
        signed int       -32767 -- +32767      (    -0x7FFF -- +0x7FFF    )
      unsigned int            0 -- +65535      (          0 -- +0xFFFF    )
              long  -2147483647 -- +2147483647 (-0x7FFFFFFF -- +0x7FFFFFFF)
       signed long  -2147483647 -- +2147483647 (-0x7FFFFFFF -- +0x7FFFFFFF)
     unsigned long            0 -- +4294967295 (          0 -- +0xFFFFFFFF)
*/

#define _BITS_OF_BASE_INT_TYPE_  8

/* base type with bit-length */
typedef unsigned char  u_int8;
typedef unsigned int   u_int16;
typedef unsigned long  u_int32;
typedef signed   char  s_int8;
typedef signed   int   s_int16;
typedef signed   long  s_int32;

/* other types */
typedef char           CHAR;           /* 0 -- 127        (0x7F) */
#define MinChar        0
#define MaxChar        0x7F
typedef u_int8         UCHAR;          /* 0 -- 255        (0xFF) */
#define MinUchar       0
#define MaxUchar       0xFF
typedef s_int16        INT;            /* -32767 -- 32767 (-0x7FFF -- 0x7FFF) */
#define MinInt         (-0x7FFF)
#define MaxInt         0x7FFF
typedef u_int16        UINT;           /* 0 -- 65535      (0xFFFF) */
#define MinUint        0
#define MaxUint        0xFFFF
typedef u_int16        USHORT;         /* 0 -- 65535      (0xFFFF) */
#define MinUshort      0
#define MaxUshort      0xFFFF
typedef u_int32        ULONG;          /* 0 -- 4294967295 (0xFFFFFFFF) */
#define MinUlong       0L
#define MaxUlong       0xFFFFFFFFL
typedef s_int32        LONG;           /* -2147483647 -- 2147483647 (-0x7FFFFFFF -- 0x7FFFFFFF) */
#define MinLong        (-0x7FFFFFFFL)
#define MaxLong        0x7FFFFFFFL

typedef UCHAR          FLAG;           /* only 0 & 1 are used. */
#define MinFlag        0
#define MaxFlag        1
typedef UCHAR          BYTE;           /* 0 -- 255        (0xFF) */
#define MinByte        0
#define MaxByte        0xFF
typedef USHORT         WORD;           /* 0 -- 65535      (0xFFFF) */
#define MinWord        0
#define MaxWord        0xFFFF
typedef ULONG          DWORD;          /* 0 -- 4294967295 (0xFFFFFFFF) */
#define MinDword       0L
#define MaxDword       0xFFFFFFFFL

typedef CHAR*          STRING;

#ifdef _USE_MY_SIZE_T_
#ifdef size_t
#undef size_t
#endif
#define _SIZE_T
typedef UINT           size_t;
#else
#include <stddef.h>
#endif


#ifdef _LOWCASE_TYPEDEF_
/*typedef CHAR   char  ;  it is forbidden to redefine type 'char' */
  typedef UCHAR  uchar ;
/*typedef INT    int   ;  it is forbidden to redefine type 'int' */
  typedef UINT   uint  ;
/*typedef USHORT ushort;  'ushort' has not been defined in an early version */
  typedef ULONG  ulong ;
/*typedef LONG   long  ;  it is forbidden to redefine type 'long' */
  typedef FLAG   flag  ;
  typedef BYTE   byte  ;
/*typedef WORD   word  ;  'word' has not been defined in an early version */
/*typedef DWORD  dword ;  'dword' has not been defined in an early version */
  typedef STRING string;
#endif /* _LOWCASE_TYPEDEF_ */


/*
 * Macros
 */

#ifdef bitsof
#error Macro bitsof already defined.
#endif
#define bitsof(type) (_BITS_OF_BASE_INT_TYPE_ * sizeof(type))


/*
 * Other types & constants
 */

typedef unsigned char   BOOL;
typedef unsigned char   BINARY;

typedef double          REAL;

#define TRUE            1
#define FALSE           0
#define PI              3.1415926535897932384626434

#else /* __TYPES_H__ */

#ifndef __COMMON_TYPES_TYPES_H__
#error This header file conflicts with another "types.h" file.
#endif

#endif
